package org.wronka.matt.util;

public class Convert {
	public static String Text2HTML(String txt) {
		StringBuffer sb = new StringBuffer(txt);
		int curr_index;
		while( (curr_index = sb.indexOf(">")) >= 0) {
			sb.replace(curr_index, curr_index+1, "&gt;");
		}
		while( (curr_index = sb.indexOf("<")) >= 0) {
			sb.replace(curr_index, curr_index+1, "&lt;");
		}
		while( (curr_index = sb.indexOf("\n")) >= 0) {
			sb.replace(curr_index, curr_index+1, "<br>");
		}
		return sb.toString();
	}
	public static String HTML2Text(String html) {
		StringBuffer sb = new StringBuffer(html);
		int curr_index = 0;
		while(true) {
			curr_index = sb.indexOf("<");
			int endex = sb.indexOf(">", curr_index)+1;
			if(curr_index < 0 || endex < 0) break;
			if(sb.substring(curr_index+1, endex-1).trim().equals("br")) {
				sb.replace(curr_index, endex, "\n");
			} else if(sb.substring(curr_index+1, endex-1).trim().
					equals("p")) {
				sb.replace(curr_index, endex, "\n");
			} else if(sb.substring(curr_index+1, endex-1).trim().
					equals("li")) {
				sb.replace(curr_index, endex, "\n\t");
			} else if(sb.substring(curr_index+1, endex-1).trim().
					equals("/ul")) {
				sb.replace(curr_index, endex, "\n");
			} else {
				sb.delete(curr_index, endex);
			}
		}
		curr_index = 0; //entities
		while( (curr_index = sb.indexOf("&")) >= 0) {
			int endex = sb.indexOf(";", curr_index)+1;
			if(endex<=0) break;	// error, bail out
			String entity, replaced;
			entity = sb.substring(curr_index+1,endex-1);
			if(entity.equals("gt")) {
				replaced = ">";
			} else if(entity.equals("lt")) {
				replaced = "<";
			} else if(entity.equals("amp")) {
				replaced = "&";
			} else {
				replaced = "??";
			//	replaced = entity;
			}
			sb.replace(curr_index, endex, replaced);
		}
		return sb.toString();
	}
}
